<?php

// Данный код написан для примера.
// Положите данный файл на сервер в нужную вам директорию и пропишите в кабинете конструктора URL данного файла.
// Здесь могут быть описаны не все данные, приходящие в запросе. Проверяйте их самостоятельно из переменных $_POST и $_FILES.
// Здесь не преследуется цель безопасности или обработки ошибок, это ваша задача.
// Обрабатывайте ошибки как следует, не оставляйте код оптимистичным как здесь.
// Если не позаботитесь о безопасности и оставите как есть, то на ваш сервер любой сможет загрузить что угодно.
// URL данного обработчика должен начинаться с HTTPS, иначе личные данные ваших клиентов перехватят.
// Если вы будете складировать данные в директории как здесь, то убедитесь, что они закрыты от листинга и просмотра файлов.
// Тестировать данный обработчик можно заказами из вашего конструктора.
// Поскольку вы не можете видеть весь процесс общения серверов, вы можете обратиться на support@cosuv.ru для уточнения причины проблемы.

// Данные заказа
$info_json = $_POST['info'];
$info = json_decode( $info_json, true );

// Путь к скачиванию zip-архива (например для создания ссылки на скачивание с сервера конструктора)
$zip_download_url = $_POST['zipDownloadURL'];

// Создаём папку, в которую будем складировать архивы заказов, их данные и превью
$save_dir = __DIR__ . DIRECTORY_SEPARATOR . 'orders' . DIRECTORY_SEPARATOR . $info['id'];
if( !is_dir($save_dir) ) mkdir( $save_dir, 0755, true );

// Сохранение данных заказа в файл .json
file_put_contents( $save_dir.DIRECTORY_SEPARATOR.'info.json', json_encode( $info, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE ) );

// Сохранение zip-архива, пришедшего в post-данных
$zip_file = $_FILES['zipData'];
move_uploaded_file( $zip_file['tmp_name'], $save_dir.DIRECTORY_SEPARATOR.$zip_file['name'] );

// Сохранение превью (основного, созданного сервером конструктора), пришедшего в post-данных
// Вместо файла может быть строка 'none' в $_POST если файла нет, поэтому можете проверять что $_POST['altThumbData'] не равно 'none',
// и использовать альтернативное превью, описанное ниже.
$thumb_file = $_FILES['thumbData'];
move_uploaded_file( $thumb_file['tmp_name'], $save_dir.DIRECTORY_SEPARATOR.$thumb_file['name'] );

// Сохранение альтернативного превью (имитиации браузером клиента), пришедшего в post-данных.
// Вместо файла может быть строка 'none' в $_POST если файла нет, поэтому можете проверять что $_POST['altThumbData'] не равно 'none'.
$alt_thumb_file = $_FILES['altThumbData'];
move_uploaded_file( $alt_thumb_file['tmp_name'], $save_dir.DIRECTORY_SEPARATOR.$alt_thumb_file['name'] );

// Сохраняем данные последнего запроса для дебага
$post_data_readable = print_r( $_POST, true );
file_put_contents( './post-debug.txt', $post_data_readable );
$files_data_readable = print_r( $_FILES, true );
file_put_contents( './files-debug.txt', $files_data_readable );

// В POST-данных есть ссылка на редактирование заказа:
// $edit_url = $_POST['editURL'];

// В конце нужно выдать 'success' в теле ответа, иначе сервер конструктора будет думать,
// что призошла ошибка во время обработки, или что обработчика нет по данному адресу.
echo 'success';